Attribute VB_Name = "Module1"
Sub DeleteExcessGDrillRows()
Attribute DeleteExcessGDrillRows.VB_Description = "Ctrl+Shift+D   Deletes the excess rows from the G-Drill code\nAnd creates a sheet G-Drill-C (clean)"
Attribute DeleteExcessGDrillRows.VB_ProcData.VB_Invoke_Func = "D\n14"
'
' DeleteDrillRows Macro
' Ctrl+Shift+D  removes the non-functional lines from Drill Gcode
'
' Keyboard Shortcut: Ctrl+Shift+D
'
' delete all lines containing a first character "%"

'Copy Gcode data to G-Drill-C (Clean) sheet then deletes all of the unwanted lines

' Checks to see if the new sheet exists and if so delete it deletes and rebuilds it
' Checks to see if the new Sheet is missing and if so runs the Main Gcode program and then creates the G-Drill-C

    Dim Test As Integer
    Test = 0
    For Each Sheet In ActiveWorkbook.Worksheets
        If Sheet.name = "G-Drill" Then
        Test = 1
        End If
    Next Sheet
    
    If Test = 0 Then
        Call PanelCreateAllSheets_Gcode
    End If
        
    Dim G_Drill_Clean As String
    G_Drill_Clean = "G-Drill-C"

    Application.DisplayAlerts = False
    For Each Sheet In ActiveWorkbook.Worksheets
        If Sheet.name = "G-Drill-C" Then
            Sheet.Delete
        End If
    Next Sheet
    Application.DisplayAlerts = True
    
    Worksheets.Add(Before:=Sheets("G-Drill")).name = G_Drill_Clean 'creates the sheet as empty

    Worksheets(G_Drill_Clean).Select
    Worksheets("G-Drill").Range("F1:" & Range("F1").End(xlDown).Address).Copy
    Worksheets(G_Drill_Clean).Range("C1").Select
    ActiveSheet.Paste  ' pastes the G-Drill sheet Gcode to the new sheet
    
    Worksheets(G_Drill_Clean).Select
' find the row and column containing the Gcode
    Dim lRow As Long
    Dim lCol As Long

'Find the last non-blank cell in row 50
    lCol = Cells(50, Columns.Count).End(xlToLeft).Column
    
'Find the last non-blank cell in column just found to contain the last Column
    lRow = Cells(Rows.Count, lCol).End(xlUp).Row
     
'   MsgBox "Last Row: " & lRow & vbNewLine & _
'       "Last Column: " & lCol
    
    ActiveSheet.Cells(1, lCol).Select  ' nothing in this column yet, but will place running total of drilling sites in this column
    
    Dim lastrow As Integer  ' This will be used to work to the last row in the sheet with data
    lastrow = lRow
    Dim TestCell
    Dim i As Integer
    Dim k As Integer
    i = 1  'counter to run through all of the rows to be tested
    k = 2  ' counter +2 of the number of non-zero (#,2) cells found.
    Dim imax As Integer
'   imax = Range("C1") ' This is the number of rows to be tested or cycled through

    MySheet = ActiveSheet.name
    lastrow = ActiveSheet.UsedRange.Rows.Count
    imax = lRow
    ActiveSheet.Cells(k, lCol).Select
    TestCell = ActiveCell  'initial cell to be tested
    Do Until i > imax  ' loop through all of the rows of interest
        TestCell = ActiveCell
        If TestCell = "%^^" Then
            Rows(k).Select   'This moves to the next row after the row with %^^
                Selection.Delete  ' should delete all rows with %^^ in cell
            i = i + 1   'This increments the index so as to skip any row that is not deleted
            ActiveSheet.Cells(k, lCol).Select
            Else
            k = k + 1
            i = i + 1 'rows being tested
            ActiveSheet.Cells(k, lCol).Select
            ActiveSheet.Cells(k - 1, 1) = k - 2
        End If
        Range("A1") = k - 2 ' the number of non-zero rows or rows with an * in column 2
    Loop

    ActiveSheet.Cells(4, 4).Select    ' when done park the cursor

'   stop  'Debug line to delete

'Remove all blank lines
    i = 1  'counter to run through all of the rows to be tested
    k = 2  ' counter +2 of the number of non-zero (#,2) cells found.
'   imax = Range("C1") ' This is the number of rows to be tested or cycled through
    MySheet = ActiveSheet.name
    lastrow = ActiveSheet.UsedRange.Rows.Count
    imax = lastrow
    ActiveSheet.Cells(k, lCol).Select
    TestCell = ActiveCell  'initial cell to be tested
    Do Until i > imax  ' loop through all of the rows of interest
        TestCell = ActiveCell
        If TestCell = "" Then
            Rows(k).Select   'This moves to the next row after the row with %^^
            Selection.Delete  ' should delete all rows with %^^ in cell of column i=9
            i = i + 1   'This increments the index so as to skip any row that is not deleted
            ActiveSheet.Cells(k, lCol).Select
        Else
            k = k + 1
            i = i + 1 'rows being tested
            ActiveSheet.Cells(k, lCol).Select
            ActiveSheet.Cells(k - 1, 1) = k - 2
        End If
        Range("A1") = k - 2 ' the number of non-zero rows or rows with an * in column 2
    Loop
    
 '      MsgBox "Add line numbers next"
        Dim StrEx As String
        Dim GcodeLine As String
        Dim Ncount As String
        Dim Nstr As String
        Nstr = "N"
        
        Cells(1, 5) = "(Below: This is the same Gcode as to the left, but with line numbers)"
    For i = 1 To Cells(1, 1).Value
        GcodeLine = Cells(i + 1, 3).Value
        StrEx = GcodeLine
        If (Left(StrEx, 1) = "O") Then
            Cells(i + 1, 5).Value = GcodeLine
        Else
            Ncount = Trim(Str(1000 + Cells(i + 1, 1).Value)) 'Trim removes unwanted white space at the beginning of a cell value
            Cells(i + 1, 5).Value = Nstr & Ncount & " " & GcodeLine
            Cells(i + 1, 5).Interior.Color = Cells(i + 1, 3).DisplayFormat.Interior.Color
        End If
    Next i
    
    
'Next Copy all of the drill hole locations, with or without Line #s so that this text can be used.

    Dim Line_Num As Variant
    Line_Num = 3
    Range("D1") = Line_Num
    Line_Num = InputBox("If you want Gcode without line numbers then hit OK" & vbNewLine & _
        "If you want to copy the Gcode with line numbers please type 5 then OK")
    If Line_Num = 5 Then
    Range("D1") = Line_Num
    Else
    End If
    
    lastrow = ActiveSheet.UsedRange.Rows.Count
'selsect the range between Row 2 and the lastrow and then copy the range

    If Line_Num = 5 Then
    Range("E2:E" & lastrow).Select
    Else
    Range("C2:C" & lastrow).Select
    End If
    Application.CutCopyMode = False
    Selection.Copy


    End Sub
