Attribute VB_Name = "Module2"
Sub PanelCreateAllSheets_Gcode()
Attribute PanelCreateAllSheets_Gcode.VB_Description = "Ctrl+Shift+M  Module2  From Param and Template Devices\nCreates: Ordered device list, Sheets, MultiDeviceGcode"
Attribute PanelCreateAllSheets_Gcode.VB_ProcData.VB_Invoke_Func = "M\n14"
'
' Ctrl+Shift+M  Module2  From uwParam and Template Devices
' Creates: Ordered device list, Sheets, MultiDeviceGcode
'

'Protect worksheet with a password
'Sheets("uwParam").Protect Password:="HM"
'Sheets("uwCirT").Protect Password:="HM"
'Sheets("uwRectT").Protect Password:="HM"
'***************

'Delete all old sheets except protected sheets such as uwParam, Templates etc. use uw... and ....T
'Call DeleteSheetsExcept
Application.DisplayAlerts = False ' This turns off=False notation of the sheet deletion
'  This deletes all sheets which either do not start with uw and/or ends with T
'  i.e. this keeps all uv starting and T ending sheets
Dim tmpL As String
Dim tmpR As String
For Each Sheet In ActiveWorkbook.Worksheets
    tmpL = Left(Sheet.name, 2)
    tmpR = Right(Sheet.name, 1)
    If tmpL = "uw" Then
        ElseIf tmpR = "T" Then
        Else: Sheet.Delete
    End If
Next Sheet
Application.DisplayAlerts = True
'***Done deleting old non-essential device sheets

'Now add a blank sheet called "Build" which will be used as a scratch pad to create the other sheets.
' Sheets.Add(Before:=Sheets(1)).Name = "FirstSheet"
' Sheets.Add(After:=Sheets(Sheets.Count)).Name = "LastSheet"

 Sheets.Add(Before:=Sheets(1)).name = "Build" 'create sheet and place at first position

' Define some numbers representing row locations in uwParam
    Worksheets("Build").Select
'    Range("C1") = Chr(Counter + 65) 'character code 65 =A, used to select column addresses in uwParam
    Range("D1").Formula = "=(" & Worksheets("uwParam").Range("B5") & ")" 'Device order number row in uwParam
    Range("E1").Formula = "=(" & Worksheets("uwParam").Range("C5") & ")" 'Device sheet name row in uwParam
    Range("F1").Formula = "=(" & Worksheets("uwParam").Range("D5") & ")" 'Device True/False row in uwParam
    Range("G1").Formula = "=(" & Worksheets("uwParam").Range("E5") & ")" 'Device Style Name in uwParam

'Get the number of devices & place it in cell A1
    
    Dim DNmax As Integer 'max number of devices defined by finding the max number in uwParam row 38
    DNmax = WorksheetFunction.Max(Worksheets("uwParam").Rows(Worksheets("uwParam").Cells(5, 2).Value))
' find the largest numbered device number
    Range("A1").Formula = DNmax 'Max number of devices listes in row(38) of uwParam
' make a list of all possible Devices that been specified in uwParam.
    Dim Counter As Integer
    For Counter = 1 To DNmax ' DNmax= total number of possible devices via the device order numbers of uwParam
    Range("C1") = Chr(Counter + 65) 'character code 65 =A, used to select column addresses in uwParam
    Worksheets("Build").Select
    Worksheets("Build").Cells(Counter + 1, 4).Select ' Device number
    Worksheets("Build").Range("A1").Select
    ActiveCell.Interior.ColorIndex = 28 ' set the color of this cell
    
    Worksheets("Build").Cells(Counter + 1, 2).Select ' Device True/False formula to be placed here
    ActiveCell = ("=uwParam!" & Chr(Counter + 65) & Worksheets("Build").Cells(1, 6).Value) 'This worked to create a formula
    ActiveCell.Interior.ColorIndex = (Counter + 11)
    Cells(Counter + 1, 7 + 15) = ActiveCell.Value 'This changes formula to value
    
    Worksheets("Build").Cells(Counter + 1, 3).Select ' Device order number formula to be placed here
    ActiveCell = ("=uwParam!" & Chr(Counter + 65) & Worksheets("Build").Cells(1, 4).Value) 'This worked to create a formula
    ActiveCell.Interior.ColorIndex = (Counter + 11)
    Cells(Counter + 1, 8 + 15) = ActiveCell.Value 'This changes formula to value
 
    Worksheets("Build").Cells(Counter + 1, 4).Select ' Device Name formula to be placed here
    ActiveCell = ("=uwParam!" & Chr(Counter + 65) & Worksheets("Build").Cells(1, 5).Value) 'This worked to create a formula
    ActiveCell.Interior.ColorIndex = (Counter + 11)
    Cells(Counter + 1, 9 + 15) = ActiveCell.Value 'This changes formula to value
    
    Worksheets("Build").Cells(Counter + 1, 1).Select ' Device STYLE formula to be placed here
    ActiveCell = ("=uwParam!" & Chr(Counter + 65) & Worksheets("Build").Cells(1, 7).Value) 'This worked to create a formula
    ActiveCell.Interior.ColorIndex = (Counter + 11)
    Cells(Counter + 1, 6 + 15) = ActiveCell.Value 'This changes formula to value
    
    Worksheets("Build").Cells(Counter + 1, 5).Select ' Original uwParam Device Arrangement order formula to be placed here
    '    ActiveCell = ("=uwParam!" & Chr(Counter + 65) & Worksheets("Build").Cells(1, 7).Value) 'This worked to create a formula
    ActiveCell = Counter
    ActiveCell.Interior.ColorIndex = (Counter + 11)
'    Cells(Counter + 1, 10) = ActiveCell.Value 'This changes formula to value
    
    Next Counter
' Done making the Initial Device list
   
'****************************************
' Sort the device list Range by the True/False and then by device order number
' This then makes a list of the devices to actually be built, in the order specified.
' This list will be used to create the devices sheets of the devices to be built.
    
'    Range("A2:I18").Select
    Range("A2:I" & Counter).Select
    ActiveWorkbook.Worksheets("Build").Sort.SortFields.Clear
    ActiveWorkbook.Worksheets("Build").Sort.SortFields.Add Key:=Range("B2:B" & Counter), _
        SortOn:=xlSortOnValues, Order:=xlDescending, DataOption:=xlSortNormal
    ActiveWorkbook.Worksheets("Build").Sort.SortFields.Add Key:=Range("C2:C" & Counter), _
        SortOn:=xlSortOnValues, Order:=xlAscending, DataOption:=xlSortNormal
    With ActiveWorkbook.Worksheets("Build").Sort
        .SetRange Range("A2:E" & Counter)
        .Header = xlGuess
        .MatchCase = False
        .Orientation = xlTopToBottom
        .SortMethod = xlPinYin
        .Apply
    End With
       
'****************************************
' Create Blank Devices Sheets for TRUE Devices using the list shown in the Build sheet
' Then Populate them with uwParam cells formulas with correct device values from uwParam

    Dim DeviceBuild As Integer
    Dim DCount As Integer
    Dim DCmax As Integer
    Dim DeviceStyle As String
    
 ' Count the number of True Devices
    DCount = 0
    For Counter = 1 To DNmax ' DNmax= total number of possible devices via the device order numbers of uwParam
        DeviceStyle = Range("A" & Counter + 1)
        If Range("B" & Counter + 1).Value = True Then
        DCount = DCount + 1
        DCmax = DCount  ' DCmax= the total number of devices from which to generate Gcode
        End If
    Next Counter
'    Range("L1") = DCount        'Debug observation, not really needed.
'    Range("M1") = DeviceStyle  'Debug observation, not really needed.

' Sub CreateWorksheets()
    Dim Names_Of_Sheets As Range
    Set Names_Of_Sheets = Sheets("Build").Range("D2:D" & DCmax + 1)
    Dim No_Of_Sheets_to_be_Added As Integer
    Dim Sheet_Name As String
    Dim i As Integer
 
    No_Of_Sheets_to_be_Added = Names_Of_Sheets.Rows.Count 'Redundent to DCmax
'    Range("O1") = No_Of_Sheets_to_be_Added  'Debug observation, not really needed.

    For i = 1 To No_Of_Sheets_to_be_Added
    Sheet_Name = Names_Of_Sheets.Cells(i, 1).Value

'Delete Sheet if it already exists from history
       Dim Work_sheet As Worksheet
 '       Application.DisplayAlerts = False
        For Each Work_sheet In ThisWorkbook.Worksheets
           If Work_sheet.name = Sheet_Name Then
               Work_sheet.Delete
           End If
           Next 'For Each Work_sheet etc
    
    Worksheets.Add(After:=Sheets("uwParam")).name = Sheet_Name
    Application.DisplayAlerts = True
    
' First:  Copy the Entire Template sheet into the newly created sheet. Which Template is to be copied
' is determined via comparison of the "DeviceStyle" to all possible Templates.
' Then Replace the individual cells in the device worksheet formulas to reflect the correct uwParam cell locations
     
    Sheets("Build").Select
    DeviceStyle = Range("A" & i + 1).Value
'    Range("N" & i + 1) = DeviceStyle    'Debug observation, not really needed.
'    Range("P" & i + 1) = Sheet_Name     'Debug observation, not really needed.
' If new, additional, Templates are constructed, then they need to be added to the following ElseIf tree so that
' they can be copied into the current sheet that is under construction.

        If DeviceStyle = "Rectangle" Then
            Sheets("uwRectT").Select
            Cells.Select
            Selection.Copy  'copy ALL of the device template sheet cells
        ElseIf DeviceStyle = "Circle" Then
            Sheets("uwCirT").Select
            Cells.Select
            Selection.Copy
        ElseIf DeviceStyle = "RectPlateOD" Then
            Sheets("uwPlateODT").Select
            Cells.Select
            Selection.Copy
        ElseIf DeviceStyle = "Dsub" Then
            Sheets("uwDsubT").Select
            Cells.Select
            Selection.Copy
'        ElseIf DeviceStyle = "TBD" Then
'            Sheets("uwTBDT").Select
'            Cells.Select
'            Selection.Copy
            
            'copy ALL of the device template sheet cells
            ' Any new device Templates would go here as another ElseIf: .i.e.
'        ElseIf DeviceStyle = "New Device Style" Then
'            Sheets("New Device Sheet Name").Select
'            Cells.Select
'            Selection.Copy  'copy ALL of the device template sheet cells
            ' Any new device Templates would go here as another ElseIf
        End If
    Sheets(Sheet_Name).Select 'Goes to the newly generated device sheet
    Range("A1").Select  ' positioning for sheet paste
    ActiveSheet.Paste   ' Pastes the device Template sheet into the newly generated device sheet
    
' Correct the Device sheet values to the uwParam Column values of the particular device
    Dim PRCoun As Integer  'uwParam_Row_Counter
    Dim Startrow As Integer
    Dim Endrow As Integer
    Dim Indx As Integer
        
    Startrow = Worksheets("uwCirT").Range("E6").Value  'Starting Row # to insert device specific formula into
    Endrow = Worksheets("uwCirT").Range("F6").Value  'Ending Row # to insert device specific formula into
    Indx = 0
    For PRCoun = Startrow To Endrow ' row sets selected to paste into
        Worksheets(Sheet_Name).Cells(PRCoun, 1).Select ' Device Name formula to be placed here
        ActiveCell = ("=uwParam!" & Chr(Worksheets("Build").Cells(i + 1, 5).Value + 65) & Worksheets("Build").Cells(1, 5).Value + Indx) 'Location to place formula  uwParam!V41
        Worksheets(Sheet_Name).Cells(PRCoun, 3).Select ' Device Name formula to be placed here
        ActiveCell = ("=uwParam!" & Chr(65) & Worksheets("Build").Cells(1, 5).Value + Indx) 'Location to place formula  uwParam!V41
        Indx = Indx + 1
        Next PRCoun
        Worksheets(Sheet_Name).Cells(1, 1).Select  'move to the top of this sheet
    Next i      'To No_Of_Sheets_to_be_Added

'Done ************** Completes building the device Sheets
'*********************************************************************************
'*********************************************************************************
'*********************************************************************************
'*********************************************************************************

' Next: Build the Gcode for the True device sheets just constructed, actually in two different formats
'    plus a Gcode sheet for drilling the starting holes for the plunge holes of milling.
' At the end of the macro the Gcode W/O lots of comments will be copied to the board for pasting into a simulator.
    Sheets("Build").Select
    Dim DrillGcodeDevices As String
    Dim LongGcodeDevices As String
    Dim ShortGcodeDevices As String
    Dim GcodeAll As String
    DrillGcodeDevices = "G-Drill"
    LongGcodeDevices = "G-Long"
    ShortGcodeDevices = "G-Short"
    GcodeAll = "G-All"
    
    Worksheets.Add(After:=Sheets("Build")).name = DrillGcodeDevices 'creates the sheet to hold the multiDevice Gcode for Drilling plunge holes
    Worksheets.Add(After:=Sheets("Build")).name = LongGcodeDevices 'creates the sheet to hold the multiDevice Gcode with long comments
    Worksheets.Add(After:=Sheets("Build")).name = ShortGcodeDevices 'creates the sheet to hold the multiDevice Gcode with short comments
 '   Worksheets.Add(After:=Sheets("Build")).name = GcodeAll 'creates the sheet to hold the multiDevice All 3 sets of Gcode, decided not to make
    
' Add Gcode Main Startup header lines
' Take some of these from the uwCirT template device Gcode as they are repeated on every device style
    Dim GCRStart1 As Integer    'Row location of Gcode lines on Device sheet: Starting line of Openning Gcode for Main
    Dim GCRLast1 As Integer    'Row location of Gcode lines on Device sheet: Ending line of Openning Gcode for Main
    Dim GCRStart2 As Integer    'Row location on Gcode lines on Device sheet: Subroutine call for device
    Dim GCRLast2 As Integer    'Row location on Gcode lines on Device sheet: Ending line of Subroutine call for device
    Dim GCRStart3 As Integer    'Row location on Gcode lines on Device sheet: Starting line of Closing Gcode for Main
    Dim GCRLast3 As Integer    'Row location on Gcode lines on Device sheet: Ending line of Closing Gcode for Main
    Dim GCRStart4 As Integer    'Row location on Gcode lines on Device sheet: Starting line of Subroutines
    Dim GCRLast4 As Integer     'Row location on Gcode lines on Device sheet: Ending line of Gcode for Subroutine on Device sheet
    GCRStart1 = Worksheets("uwCirT").Range("E4").Value    'This Row start and stop location are Taken from the actual device sheet
    GCRLast1 = Worksheets("uwCirT").Range("E5").Value     'This Row start and stop location are Taken from the actual device sheet
    'GCRStart2 = Worksheets("???").Range("F4").Value    'This Row start and stop location are Taken from the actual device sheet
    'GCRLast2 = Worksheets("???").Range("F5").Value     'This Row start and stop location are Taken from the actual device sheet
    GCRStart3 = Worksheets("uwCirT").Range("G4").Value    'This Row start and stop location are Taken from the actual device sheet
    GCRLast3 = Worksheets("uwCirT").Range("G5").Value     'This Row start and stop location are Taken from the actual device sheet
    'GCRStart4 = Worksheets("???").Range("H4").Value    'This is Device Style Dependent and so will be determined when actually needed
    'GCRLast4 = Worksheets("???").Range("H5").Value     'This is Device Style Dependent and so will be determined when actually needed

'
    Dim GCCStart1 As String    'Column location of Long Comment Gcode lines on Device sheet.
    Dim GCCStart2 As String    'Column location of Short Comment Gcode lines on Device sheet.
    Dim GCCStart3 As String   'Column location of Drilling Gcode lines on Device sheet.
    'GCCStart1 = Chr(Worksheets("???").Range("E7") + 64)  ' Column letter where the Long comment Gcode is located,Device Style Dependent
    'GCCStart2 = Chr(Worksheets("???").Range("F7") + 64)  ' Column letter where the Short comment Gcode is located,Device Style Dependent
    'GCCStart3 = Chr(Worksheets("???").Range("G7") + 64)  ' Column letter where the Drilling Gcode is located,Device Style Dependent
    Dim Coladd1 As Integer
    Dim Coladd2 As Integer
    Dim Coladd3 As Integer
    
    Dim CurentWkShtName As String  ' will be the device worksheet name being used to construct the Gcode from
    
' First Step: Insert the Preamble Gcode from uwCirT into the G-Short, G-Long and G-Drill sheets.  The same preamble for all devices so use uwCirT
    Dim firsGCr As Integer 'first row # to place Gcode line into for current operation
    Dim lastGCr As Integer 'last row # to place Gcode line into  for current operation
    
'    GCCStart1 = Chr(Worksheets("uwCirT").Range("E7") + 64)  ' This is the column letter where the Long comment Gcode is located
'    GCCStart2 = Chr(Worksheets("uwCirT").Range("F7") + 64)  ' This is the column letter where the Short comment Gcode is located
'    GCCStart3 = Chr(Worksheets("uwCirT").Range("G7") + 64)  ' This is the column letter where the Drilling Gcode is located
    
    Coladd1 = (Worksheets("uwCirT").Range("E7"))  ' This is the column # where the Long comment Gcode is located
    Coladd2 = (Worksheets("uwCirT").Range("F7"))  ' This is the column # where the Short comment Gcode is located
    Coladd3 = (Worksheets("uwCirT").Range("G7"))  ' This is the column # where the Drilling Gcode is located
    
            'This allows for column letters to be beyond Z, upto BZ, overkill!
    If Coladd1 > 52 Then
        GCCStart1 = ("B" & Chr(Coladd1 + 64 - 52))
    ElseIf Coladd1 > 26 Then
        GCCStart1 = ("A" & Chr(Coladd1 + 64 - 26))
    Else
        GCCStart1 = Chr(Coladd1 + 64)
    End If
    
    If Coladd2 > 52 Then
        GCCStart2 = ("B" & Chr(Coladd2 + 64 - 52))
    ElseIf Coladd2 > 26 Then
        GCCStart2 = ("A" & Chr(Coladd2 + 64 - 26))
    Else
        GCCStart2 = Chr(Coladd2 + 64)
    End If

    If Coladd3 > 52 Then
        GCCStart3 = ("B" & Chr(Coladd3 + 64 - 52))
    ElseIf Coladd3 > 26 Then
        GCCStart3 = ("A" & Chr(Coladd3 + 64 - 26))
    Else
        GCCStart3 = Chr(Coladd3 + 64)
    End If
    
' Now insert the Preamble lines of the main program.  Always get these from sheet uwCirT.  So define the Row
' start and stop locations via getting the row numbers from the uwCirT template.

    GCRStart1 = Worksheets("uwCirT").Range("E4").Value    'This start and stop location are Device Style independent
    GCRLast1 = Worksheets("uwCirT").Range("E5").Value     'This start and stop location are Device Style independent
        
    firsGCr = 10  ' row number where we start Assembling the Gcode for multiple devices, i.e leave 10 blank lines at the top
    lastGCr = firsGCr + GCRLast1 - GCRStart1  ' 17, first 8 entries of headers will be the Gcode start up for the Main program
    
    For Counter = firsGCr To lastGCr ' 10 to (10+7=17)  'For these lines uwCirT anad uwRectT are the same so either Sheet line numbers are ok.
    Worksheets(LongGcodeDevices).Range("B" & 0 + Counter).Value = Worksheets("uwCirT").Range(GCCStart1 & GCRStart1 + Counter - firsGCr).Value
    Worksheets(LongGcodeDevices).Range("B" & 0 + Counter).Interior.ColorIndex = (3)
        Worksheets(ShortGcodeDevices).Range("D" & 0 + Counter).Value = Worksheets("uwCirT").Range(GCCStart2 & GCRStart1 + Counter - firsGCr).Value
        Worksheets(ShortGcodeDevices).Range("D" & 0 + Counter).Interior.ColorIndex = (3)
            Worksheets(DrillGcodeDevices).Range("F" & 0 + Counter).Value = Worksheets("uwCirT").Range(GCCStart3 & GCRStart1 + Counter - firsGCr).Value
            Worksheets(DrillGcodeDevices).Range("F" & 0 + Counter).Interior.ColorIndex = (3)
    Next Counter
' Done with inserting the Gcode Main header lines

' Second Step: Insert the Main Subroutine Call Gcode line for each device. Only a single call line per device so no loops required here
'   If one wanted to have multiple Subroutine Calls per device then more lines and a loop might be needed??
    
    firsGCr = lastGCr + 1 ' for above conditions the first row will be 18

    For Counter = 1 To DCmax 'increment through each True Device, the last row to be filled will be 18+DCmax= 22
    CurentWkShtName = Worksheets("Build").Range("D" & Counter + 1).Value
    Coladd1 = Worksheets(CurentWkShtName).Range("E7")  ' This is the column numberletter where the Long comment Gcode is located
    Coladd2 = Worksheets(CurentWkShtName).Range("F7")  ' This is the column number/letter where the Short comment Gcode is located
    Coladd3 = Worksheets(CurentWkShtName).Range("G7")  ' This is the column number/letter where the Drill Gcode is located
            
            'This allows for column letters to be beyond Z, upto BZ, overkill!
    If Coladd1 > 52 Then
        GCCStart1 = ("B" & Chr(Coladd1 + 64 - 52))
    ElseIf Coladd1 > 26 Then
        GCCStart1 = ("A" & Chr(Coladd1 + 64 - 26))
    Else
        GCCStart1 = Chr(Coladd1 + 64)
    End If
    
    If Coladd2 > 52 Then
        GCCStart2 = ("B" & Chr(Coladd2 + 64 - 52))
    ElseIf Coladd2 > 26 Then
        GCCStart2 = ("A" & Chr(Coladd2 + 64 - 26))
    Else
        GCCStart2 = Chr(Coladd2 + 64)
    End If

    If Coladd3 > 52 Then
        GCCStart3 = ("B" & Chr(Coladd3 + 64 - 52))
    ElseIf Coladd3 > 26 Then
        GCCStart3 = ("A" & Chr(Coladd3 + 64 - 26))
    Else
        GCCStart3 = Chr(Coladd3 + 64)
    End If
    
' Use the starting row line number of the current Template Style which has been copied into the Device current work sheet
'    GCRStart1 = Worksheets(CurentWkShtName).Range("E4").Value    'This start and stop location are Device Style dependent
'    GCRLast1 = Worksheets(CurentWkShtName).Range("E5").Value     'This start and stop location are Device Style dependent
    GCRStart2 = Worksheets(CurentWkShtName).Range("F4").Value    'This start and stop location are Device Style dependent
    GCRLast2 = Worksheets(CurentWkShtName).Range("F5").Value     'This start and stop location are Device Style dependent
'    GCRStart3 = Worksheets(CurentWkShtName).Range("G4").Value    'This start and stop location are Device Style dependent
'    GCRLast3 = Worksheets(CurentWkShtName).Range("G5").Value     'This start and stop location are Device Style dependent
           
    Worksheets(LongGcodeDevices).Range("B" & lastGCr + Counter).Value = Worksheets(CurentWkShtName).Range(GCCStart1 & GCRStart2).Value
'    Worksheets(LongGcodeDevices).Range("B" & lastGCr + Counter).Value = Worksheets(Worksheets("Build").Range("D" & Counter + 1).Value).Range("R" & GCRStart2).Value
    Worksheets(LongGcodeDevices).Range("B" & lastGCr + Counter).Interior.ColorIndex = (38)
        Worksheets(ShortGcodeDevices).Range("D" & lastGCr + Counter).Value = Worksheets(CurentWkShtName).Range(GCCStart2 & GCRStart2).Value
'        Worksheets(ShortGcodeDevices).Range("D" & lastGCr + Counter).Value = Worksheets(Worksheets("Build").Range("D" & Counter + 1).Value).Range("V" & GCRStart2).Value
        Worksheets(ShortGcodeDevices).Range("D" & lastGCr + Counter).Interior.ColorIndex = (38)
            Worksheets(DrillGcodeDevices).Range("F" & lastGCr + Counter).Value = Worksheets(CurentWkShtName).Range(GCCStart3 & GCRStart2).Value
'            Worksheets(DrillGcodeDevices).Range("F" & lastGCr + Counter).Value = Worksheets(Worksheets("Build").Range("D" & Counter + 1).Value).Range("X" & GCRStart2).Value
            Worksheets(DrillGcodeDevices).Range("F" & lastGCr + Counter).Interior.ColorIndex = (38)

    Next Counter
' Done with insertion of the Main Subroutine Calls
  
    firsGCr = firsGCr + DCmax  '18+5 = 23  This will be the next first row to be filled with the next lines


'************************************************************************
' Add Gcode for Main Program Closing lines (Post-Amble)
    Dim NCloseLines As Integer  'Device number of lines in Subroutine Gcodes for this Sheet_Name device
    Coladd1 = Worksheets("uwCirT").Range("E7")  ' This is the column letter where the Long comment Gcode is located
    Coladd2 = Worksheets("uwCirT").Range("F7")  ' This is the column letter where the Short comment Gcode is located
    Coladd3 = Worksheets("uwCirT").Range("G7")  ' This is the column letter where the Drilling Gcode is located
    
            'This allows for column letters to be beyond Z, upto BZ, overkill!
    If Coladd1 > 52 Then
        GCCStart1 = ("B" & Chr(Coladd1 + 64 - 52))
    ElseIf Coladd1 > 26 Then
        GCCStart1 = ("A" & Chr(Coladd1 + 64 - 26))
    Else
        GCCStart1 = Chr(Coladd1 + 64)
    End If
    
    If Coladd2 > 52 Then
        GCCStart2 = ("B" & Chr(Coladd2 + 64 - 52))
    ElseIf Coladd2 > 26 Then
        GCCStart2 = ("A" & Chr(Coladd2 + 64 - 26))
    Else
        GCCStart2 = Chr(Coladd2 + 64)
    End If

    If Coladd3 > 52 Then
        GCCStart3 = ("B" & Chr(Coladd3 + 64 - 52))
    ElseIf Coladd3 > 26 Then
        GCCStart3 = ("A" & Chr(Coladd3 + 64 - 26))
    Else
        GCCStart3 = Chr(Coladd3 + 64)
    End If
      
'  The Post-Amble lines of code for the Main program are taken from the uwCirT template.
    GCRStart3 = Worksheets("uwCirT").Range("G4").Value    'This start and stop location are Device Style independent
    GCRLast3 = Worksheets("uwCirT").Range("G5").Value     'This start and stop location are Device Style independent
      
    Worksheets("uwCirT").Select
    NCloseLines = 0    'Use the lines GCRStart3 to GCRLast3 but will then need a loop
    For Counter = firsGCr To firsGCr + GCRLast3 - GCRStart3 ' 0 to... so the last row to be filled will be 22+GCRLast3-GCRStart3=22+2=24
    Worksheets(LongGcodeDevices).Range("B" & Counter).Value = Worksheets("uwCirT").Range(GCCStart1 & GCRStart3 + 0 + NCloseLines).Value
    Worksheets(LongGcodeDevices).Range("B" & Counter).Interior.ColorIndex = (3)
        Worksheets(ShortGcodeDevices).Range("D" & Counter).Value = Worksheets("uwCirT").Range(GCCStart2 & GCRStart3 + 0 + NCloseLines).Value
        Worksheets(ShortGcodeDevices).Range("D" & Counter).Interior.ColorIndex = (3)
            Worksheets(DrillGcodeDevices).Range("F" & Counter).Value = Worksheets("uwCirT").Range(GCCStart3 & GCRStart3 + 0 + NCloseLines).Value
            Worksheets(DrillGcodeDevices).Range("F" & Counter).Interior.ColorIndex = (3)
    NCloseLines = NCloseLines + 1  ' we will just count them as they are inserted
    Next Counter
    'The last row filled for DCmax=5 was 24, NCloseLiines = 2
' Done Adding Closing lines to Main Gcode
'*******************  ****************************

    firsGCr = firsGCr + GCRLast3 - GCRStart3 ' 23+2=25, This is the next row starting point

'Add Device Subroutine Gcode Lines for each device
    Dim DSLineN As Integer 'Device Subrouting Start row number
    For DCount = 1 To DCmax 'increment through each True Device
    Sheet_Name = Worksheets("Build").Range("D" & DCount + 1).Value
'    Worksheets("Build").Range("Q" & 1 + DCount) = Sheet_Name 'Debug line can be deleted
    Worksheets(Sheet_Name).Select
' Use the Subroutine row Start & Last numbers from the actual device sheet.
    GCRStart4 = Worksheets(Sheet_Name).Range("H4").Value
    GCRLast4 = Worksheets(Sheet_Name).Range("H5").Value
    Coladd1 = Worksheets(Sheet_Name).Range("E7")  ' This is the column letter where the Long comment Gcode is located
    Coladd2 = Worksheets(Sheet_Name).Range("F7")  ' This is the column letter where the Short comment Gcode is located
    Coladd3 = Worksheets(Sheet_Name).Range("G7")  ' This is the column letter where the Drilling Gcode is located
    
    
            'This allows for column letters to be beyond Z, upto BZ, overkill!
    If Coladd1 > 52 Then
        GCCStart1 = ("B" & Chr(Coladd1 + 64 - 52))
    ElseIf Coladd1 > 26 Then
        GCCStart1 = ("A" & Chr(Coladd1 + 64 - 26))
    Else
        GCCStart1 = Chr(Coladd1 + 64)
    End If
    
    If Coladd2 > 52 Then
        GCCStart2 = ("B" & Chr(Coladd2 + 64 - 52))
    ElseIf Coladd2 > 26 Then
        GCCStart2 = ("A" & Chr(Coladd2 + 64 - 26))
    Else
        GCCStart2 = Chr(Coladd2 + 64)
    End If

    If Coladd3 > 52 Then
        GCCStart3 = ("B" & Chr(Coladd3 + 64 - 52))
    ElseIf Coladd3 > 26 Then
        GCCStart3 = ("A" & Chr(Coladd3 + 64 - 26))
    Else
        GCCStart3 = Chr(Coladd3 + 64)
    End If
    
    Worksheets("Build").Range("M" & DCount + 1) = Coladd1       'debug
    Worksheets("Build").Range("N" & DCount + 1) = Coladd2       'debug
    Worksheets("Build").Range("O" & DCount + 1) = Coladd3       'debug

    Worksheets("Build").Range("P" & DCount + 1) = GCCStart1     'debug
    Worksheets("Build").Range("Q" & DCount + 1) = GCCStart2     'debug
    Worksheets("Build").Range("R" & DCount + 1) = GCCStart3     'debug
    
    
     
'    'NSubLines = Cells(Rows.Count, 18).End(xlUp).Row - GCRStart4 - 1  'Find the number of non-blank cell in the subroutines in column R
    NSubLines = GCRLast4 - GCRStart4
    
    '**************************************
    firsGCr = firsGCr - DCmax + 1          ' These 2 also worked, but made extra colored lines at the bottom of the gcode???
    lastGCr = firsGCr + NSubLines + DCmax  ' These 2 also worked, but made extra colored lines at the bottom of the gcode???
'
'

'Debug prints
'    Worksheets("Build").Range("R" & 1 + DCount) = firsGCr      'Debug line can be deleted
'    Worksheets("Build").Range("S" & 1 + DCount) = lastGCr      'Debug line can be deleted
'    Worksheets("Build").Range("T" & 1 + DCount) = Sheet_Name   'Debug line can be deleted
'    Worksheets("Build").Range("U" & 1 + DCount) = NSubLines    'Debug line can be deleted
        DSLineN = GCRStart4

        For Counter = firsGCr To lastGCr - DCmax + 1  ' changed this to prevent extra lines of color
        Worksheets(LongGcodeDevices).Range("B" & Counter + DCmax).Value = Worksheets(Sheet_Name).Range(GCCStart1 & DSLineN).Value
        Worksheets(LongGcodeDevices).Range("B" & Counter + DCmax).Interior.ColorIndex = (DCount + 11)
            Worksheets(ShortGcodeDevices).Range("D" & Counter + DCmax).Value = Worksheets(Sheet_Name).Range(GCCStart2 & DSLineN).Value
            Worksheets(ShortGcodeDevices).Range("D" & Counter + DCmax).Interior.ColorIndex = (DCount + 11)
                Worksheets(DrillGcodeDevices).Range("F" & Counter + DCmax).Value = Worksheets(Sheet_Name).Range(GCCStart3 & DSLineN).Value
                Worksheets(DrillGcodeDevices).Range("F" & Counter + DCmax).Interior.ColorIndex = (DCount + 11)
                
'         Worksheets(LongGcodeDevices).Range("B" & Counter + DCmax).Value = Worksheets(Worksheets("Build").Range("D" & DCount + 1).Value).Range(GCCStart1 & DSLineN).Value
'        Worksheets(LongGcodeDevices).Range("B" & Counter + DCmax).Interior.ColorIndex = (DCount + 11)
'            Worksheets(ShortGcodeDevices).Range("D" & Counter + DCmax).Value = Worksheets(Worksheets("Build").Range("D" & DCount + 1).Value).Range(GCCStart2 & DSLineN).Value
'            Worksheets(ShortGcodeDevices).Range("D" & Counter + DCmax).Interior.ColorIndex = (DCount + 11)
'                Worksheets(DrillGcodeDevices).Range("F" & Counter + DCmax).Value = Worksheets(Worksheets("Build").Range("D" & DCount + 1).Value).Range(GCCStart3 & DSLineN).Value
'                Worksheets(DrillGcodeDevices).Range("F" & Counter + DCmax).Interior.ColorIndex = (DCount + 11)
                              
        DSLineN = DSLineN + 1
    Next Counter 'Counter for subroutines of this Sheet_Name (device Gcode being assembled)
        firsGCr = lastGCr + 1
    Next DCount ' Counter for each device
    
    
' Done Adding Device Subroutines for each device

'*********************
' Place Post-Amble on the Drill Gcode

    Coladd1 = Worksheets("uwCirT").Range("E7")  ' This is the column letter where the Long comment Gcode is located
    
            'This allows for column letters to be beyond Z, upto BZ, overkill!
    If Coladd1 > 52 Then
        GCCStart1 = ("B" & Chr(Coladd1 + 64 - 52))
    ElseIf Coladd1 > 26 Then
        GCCStart1 = ("A" & Chr(Coladd1 + 64 - 26))
    Else
        GCCStart1 = Chr(Coladd1 + 64)
    End If
    
' need to add the number of closing lines.
    
    GCRStart3 = Worksheets("uwCirT").Range("G4").Value    'This start and stop location are Device Style independent
    GCRLast3 = Worksheets("uwCirT").Range("G5").Value     'This start and stop location are Device Style independent
    
' Add Gcode for Main program Drilling Closing lines (Post-Amble)
      
    Worksheets("uwCirT").Select
    NCloseLines = 0    'Use the lines GCRStart3 to GCRLast3 but will then need a loop
    For Counter = firsGCr To firsGCr + GCRLast3 - GCRStart3 ' 0 to... so the last row to be filled will be 22+GCRLast3-GCRStart3=22+2=24
            Worksheets(DrillGcodeDevices).Range("F" & Counter).Value = Worksheets("uwCirT").Range(GCCStart1 & GCRStart3 + 0 + NCloseLines).Value
            Worksheets(DrillGcodeDevices).Range("F" & Counter).Interior.ColorIndex = (3)
    NCloseLines = NCloseLines + 1  ' we will just count them as they are inserted
    Next Counter
    
' Done Adding Closing lines to Drilling Gcode
'*******************  ****************************

' Done Creating the Gcode for the multiple devices
'********************************************************************************
'****************************************
'Unprotect worksheet with a password
Sheets("uwParam").Unprotect Password:="HM"
Sheets("uwCirT").Unprotect Password:="HM"
Sheets("uwRectT").Unprotect Password:="HM"

    Worksheets("Build").Select  'Move screen over

' AutoFit the column widths
    Worksheets(LongGcodeDevices).Cells.EntireColumn.AutoFit
        Worksheets(ShortGcodeDevices).Cells.EntireColumn.AutoFit
            Worksheets(DrillGcodeDevices).Cells.EntireColumn.AutoFit
            
'Copy Drill data to GcodeAll sheet then delete all of the unwanted lines
    
'    Worksheets(GcodeAll).Select
 '   Worksheets(DrillGcodeDevices).Range("F1:" & Range("F1").End(xlDown).Address).Copy
 '   Worksheets(GcodeAll).Range("C1").Select
 '   ActiveSheet.Paste
        
'Copy the Long Gcode to ClipBoard
    Worksheets(ShortGcodeDevices).Select
    Range("D10:" & Range("D10").End(xlDown).Address).Select     'selects to the end of filled cells in R column
    Selection.Copy  'makes a copy available to paste into any application, i.e. Word, Notepad, Gcode simulator, etc.


End Sub

